/**
 * GNU Public License (GPL).
 *
 * This software is published under the terms of the GNU Public License (GPL),
 * a copy of which is included in this distribution.
 */

package org.jivesoftware.openfire.plugin;

import org.jivesoftware.openfire.container.Plugin;
import org.jivesoftware.openfire.container.PluginManager;
import org.jivesoftware.openfire.interceptor.PacketInterceptor;
import org.jivesoftware.openfire.interceptor.PacketRejectedException;
import org.jivesoftware.openfire.interceptor.InterceptorManager;
import org.jivesoftware.openfire.session.Session;
import org.jivesoftware.util.StringUtils;
import org.jivesoftware.util.Log;
import org.xmpp.packet.*;

import java.io.File;

public class Dropper implements Plugin, PacketInterceptor {
	private InterceptorManager interceptorManager;

	public void initializePlugin(PluginManager manager, File pluginDirectory) {	
		interceptorManager = InterceptorManager.getInstance();		
		interceptorManager.addInterceptor(this);
		Log.info("Dropper started.");
	}		

	public void destroyPlugin() {
		interceptorManager.removeInterceptor(this);
		Log.info("Dropper stopped.");
	}

	public void interceptPacket(Packet packet, Session session, boolean incoming, boolean processed)
			throws PacketRejectedException {
		if (processed) { return; }
		if (!(packet instanceof IQ)) { return; }

		IQ iq = (IQ)packet;

		if (iq.getID() != null) { return; }

		String rnd = StringUtils.randomString(12).toLowerCase();
		iq.setID(rnd);

		Log.info("Dropper: found illegal IQ packet, repaired packet:" + iq.toString());
	}
}
